/*
https://stackoverflow.com/questions/20617067/returning-function-pointer-type/20617529

http://c-faq.com/decl/spiral.anderson.html
*/
#include <stdio.h>

int sq(int x){return x * x;}
int cb(int x){return x * x * x;}
int (*ch(int z))(int){return (z < 0) ? sq : cb;}
int f(int w){return ch(w)(w);}  // square neg num and cube pos num

int main()
{
   printf("%d\n", f(-3));
   printf("%d\n", f( 3));
   printf("%d\n", f(-1));
}

/*
(prog
  (fun sq (lambda x (* x x)))
  (fun cb (lambda x (* x x x)))
  (fun ch (lambda z (if (< z 0) sq cb)))
  (fun f  (lambda w (apply (apply ch w) w))) // square neg num and cube pos num
  (print (apply f -3))
  (print (apply f  3))
  (print (apply f -1))
)
*/
