public class FunctionScope
{
   static int c = 5; // global variable

   static int f(int x)
   {
      return x*x + c;  // draw a memory picture here
   }

   static int g(int u, int v)
   {
      return f(u) + v*v*v + c;
   }

   public static void main(String[] args)
   {
      int a = 4;
      int b = c;
      {
         int s = a;
         int t = g(s, b);
         System.out.printf("%d\n", t);
      }
   }
}
/*
(prog
  (var c 5)

  (fun f
    (lambda x
      (+ (* x x) c))) // draw a memory picture here

  (fun g
    (lambda u v
      (+ (apply f u) (* v v v) c)))

  (begin
    (var a 4)
    (var b c)
    (begin
      (var s a)
      (var t (apply g s b))
      (print t)
    )
  )
)
*/
