let c = 5; // global variable

function f(x)
{
  return x*x + c;  // draw a memory picture here
}

function g(u, v)
{
  return f(u) + v*v*v + c;
}


{
  let a = 4;
  let b = c;
  {
    let s = a;
    let t = g(s, b);
    console.log(t);
  }
}

/*
(prog
  (var c 5)

  (fun f
    (lambda x
      (+ (* x x) c))) // draw a memory picture here

  (fun g
    (lambda u v
      (+ (apply f u) (* v v v) c)))

  (begin
    (var a 4)
    (var b c)
    (begin
      (var s a)
      (var t (apply g s b))
      (print t)
    )
  )
)
*/
