#include <stdio.h>

int z = 100;  // global z

int f(int x)
{
   int temp = x * x + z;
   {
      int z;  // local z
      return temp + (z = 42); // f(x) = x*x + z + {int z = 42;}
   }
}

int g(int a, int b){return a + f(b);} // g(a,b) = a + f(b)

int main()
{
   printf("%d\n", f(4));
   {
      int z = 1000;  // local z
      printf("%d\n", f(4));
   }
   printf("%d\n", g(1, 2));
}

/*
(prog
  (var z 100)                             // global z = 100
  (fun f (lambda x (+ (* x x)
                      z
                      (begin
                        (var z 42)        // local z = 42
                        z))))             // f(x) = x*x + z + {var z = 42; z}
  (fun g (lambda a b (+ a (apply f b))))  // g(a,b) = a + f(b)
  (print (apply f 4))
  (begin
     (var z 1000)           // local z = 1000
     (print (apply f 4)))   // lexical or dynamic scope?
  (print (apply g 1 2))
)
*/
