let z = 100;  // global z

let f = function(x)
{
  let temp = x * x + z;
  {
    let z;  // local z
    return temp + (z = 42); // f(x) = x*x + z + {int z = 42;}
  }
}

let g = function(a, b){return a + f(b);} // g(a,b) = a + f(b)

console.log( f(4) );
{
  let z = 1000;  // local z
  console.log( f(4) );
}
console.log( g(1, 2) );

/*
(prog
  (var z 100)                             // global z = 100
  (fun f (lambda x (+ (* x x)
                      z
                      (begin
                        (var z 42)        // local z = 42
                        z))))             // f(x) = x*x + z + {var z = 42; z}
  (fun g (lambda a b (+ a (apply f b))))  // g(a,b) = a + f(b)
  (print (apply f 4))
  (begin
     (var z 1000)           // local z = 1000
     (print (apply f 4)))   // lexical or dynamic scope?
  (print (apply g 1 2))
)
*/
